jQuery(document).ready(function ($) {
  $('.horizontal-carousel').owlCarousel({
    items: 4,
    autoPlay: true,
    pagination: false,
    navigation: true,
    navigationText: [
      '<i class="fa fa-caret-left"></i>',
      '<i class="fa fa-caret-right"></i>'
    ]
  });
  $('#slider.style-2').owlCarousel({
    items: 1, //1 items above 1000px browser width
    itemsDesktop: [
      979,
      2
    ], //1 items between 1000px and 901px
    itemsDesktopSmall: [
      768,
      2
    ], // betweem 900px and 601px
    itemsTablet: false, // inherit
    itemsMobile: [
      579,
      1
    ], // inherit
    autoPlay: true,
    pagination: false,
    navigation: true,
    navigationText: [
      '<i class="fa fa-caret-left"></i>',
      '<i class="fa fa-caret-right"></i>'
    ]
  });
  $('#slider.style-3').owlCarousel({
    items: 4,
    autoPlay: true,
    pagination: false,
    navigation: true,
    navigationText: [
      '<i class="fa fa-caret-left"></i>',
      '<i class="fa fa-caret-right"></i>'
    ]
  });
  $('.slider').owlCarousel({
    singleItem: true,
    autoPlay: true,
    pagination: false,
    navigation: true,
    navigationText: [
      '<i class="fa fa-caret-left"></i>',
      '<i class="fa fa-caret-right"></i>'
    ]
  });
  var $container = $('#slider').not('.style-3 , .style-2').find('.row')
  $container.isotope({
    masonry: {
      columnWidth: '.col-sm-3'
    }
  });
  $(window).on('load', function () {
    $container.isotope('layout')
  });
  /* ============== TWITTER ============== */
  $('.twitter-widget').each(function () {
    var $this = $(this)
    var count = $this.data('count') || ''
    var username = $this.data('username') || ''
    var content = ''
    $.ajax({
      url: 'php/tweets-json.php',
      type: 'GET',
      dataType: 'json',
      data: {
        count: count,
        username: username
      }
    }).done(function (json) {
      for (var i in json) {
        content += '<li>'
        content += json[i].tweet
        content += '<div>' + json[i].date + '</div>'
        content += '</li>\n'
      }
      $this.html(content)
    })
  });
  $('#breakingnews').BreakingNews({
    background: '#FFF',
    title: '今日头条',
    titlecolor: '#FFF',
    titlebgcolor: '#099',
    linkcolor: '#333',
    linkhovercolor: '#099',
    fonttextsize: 16,
    isbold: false,
    border: 'solid 2px #099',
    width: '100%',
    timer: 2000,
    autoplay: true,
    effect: 'slide',
  });
  /* ============== WOW JS ============== */
  // new WOW().init();
  /* ============== placeholder ============== */
  $('input, textarea').placeholder()
  $('[data-toggle="tooltip"]').tooltip()  /* ============== fitVids ============== */
  $('.fit').fitVids()  /* ============== placeholder ============== */
  $('input, textarea').placeholder();
  $('[data-toggle="tooltip"]').tooltip();
  /* ============== fitVids ============== */
  $('.fit').fitVids();
  /* ============== lazyloading ============== */
  $('.bttrlazyloading').bttrlazyloading({
    animation: 'fadeIn',
    delay: 50
  });
  /* ============== CONTACT FORM ============== */
  $('#contactform').submit(function (event) {
    var $span = $(this).find('span'),
    action = $(this).attr('action'),
    data = $(this).serialize()
    $span.removeClass('text-danger , text-success').hide().text('Sending...').fadeIn()
    $.ajax({
      url: action,
      type: 'POST',
      data: data,
      dataType: 'json'
    }).done(function (response) {
      if (response.errors) {
        $span.text(response.errors[0]).addClass('text-danger')
      } else {
        $span.text(response.success).addClass('text-success')
      }
    })
    return false
  });
  //Google Maps
  var $map = $('#map')
  if ($map.length) {
    $map.gMap({
      address: 'No: 58 A, East Madison St, Baltimore, MD, USA',
      zoom: 16,
      markers: [
        {
          'address': 'No: 58 A, East Madison St, Baltimore, MD, USA'
        }
      ]
    });
  }  //Google Maps End

});
/*88888888888888888888888888888888888888888888888888888*/
/*

Uses excanvas for IE8 and jQuery Knob plugin built by anthony terrien.

http://anthonyterrien.com/knob/

*/
document.createElement('canvas').getContext || !function () {
  function t() {
    return this.context_ || (this.context_ = new l(this))
  }
  function e(t, e) {
    var i = C.call(arguments, 2);
    return function () {
      return t.apply(e, i.concat(C.call(arguments)))
    }
  }
  function i(t) {
    var e = t.srcElement;
    switch (t.propertyName) {
      case 'width':
        e.style.width = e.attributes.width.nodeValue + 'px',
        e.getContext().clearRect();
        break;
      case 'height':
        e.style.height = e.attributes.height.nodeValue + 'px',
        e.getContext().clearRect()
    }
  }
  function r(t) {
    var e = t.srcElement;
    e.firstChild && (e.firstChild.style.width = e.clientWidth + 'px', e.firstChild.style.height = e.clientHeight + 'px')
  }
  function s() {
    return [[1,
    0,
    0],
    [
      0,
      1,
      0
    ],
    [
      0,
      0,
      1
    ]]
  }
  function n(t, e) {
    for (var i = s(), r = 0; 3 > r; r++) for (var n = 0; 3 > n; n++) {
      for (var a = 0, o = 0; 3 > o; o++) a += t[r][o] * e[o][n];
      i[r][n] = a
    }
    return i
  }
  function a(t, e) {
    e.fillStyle = t.fillStyle,
    e.lineCap = t.lineCap,
    e.lineJoin = t.lineJoin,
    e.lineWidth = t.lineWidth,
    e.miterLimit = t.miterLimit,
    e.shadowBlur = t.shadowBlur,
    e.shadowColor = t.shadowColor,
    e.shadowOffsetX = t.shadowOffsetX,
    e.shadowOffsetY = t.shadowOffsetY,
    e.strokeStyle = t.strokeStyle,
    e.globalAlpha = t.globalAlpha,
    e.arcScaleX_ = t.arcScaleX_,
    e.arcScaleY_ = t.arcScaleY_,
    e.lineScale_ = t.lineScale_
  }
  function o(t) {
    var e,
    i = 1;
    if (t = String(t), 'rgb' == t.substring(0, 3)) {
      var r = t.indexOf('(', 3),
      s = t.indexOf(')', r + 1),
      n = t.substring(r + 1, s).split(',');
      e = '#';
      for (var a = 0; 3 > a; a++) e += T[Number(n[a])];
      4 == n.length && 'a' == t.substr(3, 1) && (i = n[3])
    } else e = t;
    return {
      color: e,
      alpha: i
    }
  }
  function h(t) {
    switch (t) {
      case 'butt':
        return 'flat';
      case 'round':
        return 'round';
      case 'square':
      default:
        return 'square'
    }
  }
  function l(t) {
    this.m_ = s(),
    this.mStack_ = [
    ],
    this.aStack_ = [
    ],
    this.currentPath_ = [
    ],
    this.strokeStyle = '#000',
    this.fillStyle = '#000',
    this.lineWidth = 1,
    this.lineJoin = 'miter',
    this.lineCap = 'butt',
    this.miterLimit = 1 * S,
    this.globalAlpha = 1,
    this.canvas = t;
    var e = t.ownerDocument.createElement('div');
    e.style.width = t.clientWidth + 'px',
    e.style.height = t.clientHeight + 'px',
    e.style.overflow = 'hidden',
    e.style.position = 'absolute',
    t.appendChild(e),
    this.element_ = e,
    this.arcScaleX_ = 1,
    this.arcScaleY_ = 1,
    this.lineScale_ = 1
  }
  function c(t, e, i, r) {
    t.currentPath_.push({
      type: 'bezierCurveTo',
      cp1x: e.x,
      cp1y: e.y,
      cp2x: i.x,
      cp2y: i.y,
      x: r.x,
      y: r.y
    }),
    t.currentX_ = r.x,
    t.currentY_ = r.y
  }
  function u(t) {
    for (var e = 0; 3 > e; e++) for (var i = 0; 2 > i; i++) if (!isFinite(t[e][i]) || isNaN(t[e][i])) return !1;
    return !0
  }
  function _(t, e, i) {
    if (u(e) && (t.m_ = e, i)) {
      var r = e[0][0] * e[1][1] - e[0][1] * e[1][0];
      t.lineScale_ = v(x(r))
    }
  }
  function f(t) {
    this.type_ = t,
    this.x0_ = 0,
    this.y0_ = 0,
    this.r0_ = 0,
    this.x1_ = 0,
    this.y1_ = 0,
    this.r1_ = 0,
    this.colors_ = [
    ]
  }
  function p() {
  }
  var y = Math,
  g = y.round,
  d = y.sin,
  m = y.cos,
  x = y.abs,
  v = y.sqrt,
  S = 10,
  w = S / 2,
  C = Array.prototype.slice,
  b = {
    init: function (t) {
      if (/MSIE/.test(navigator.userAgent) && !window.opera) {
        var i = t || document;
        i.createElement('canvas'),
        i.attachEvent('onreadystatechange', e(this.init_, this, i))
      }
    },
    init_: function (t) {
      if (t.namespaces.g_vml_ || t.namespaces.add('g_vml_', 'urn:schemas-microsoft-com:vml', '#default#VML'), t.namespaces.g_o_ || t.namespaces.add('g_o_', 'urn:schemas-microsoft-com:office:office', '#default#VML'), !t.styleSheets.ex_canvas_) {
        var e = t.createStyleSheet();
        e.owningElement.id = 'ex_canvas_',
        e.cssText = 'canvas{display:inline-block;overflow:hidden;text-align:left;width:300px;height:150px}g_vml_\\:*{behavior:url(#default#VML)}g_o_\\:*{behavior:url(#default#VML)}'
      }
      for (var i = t.getElementsByTagName('canvas'), r = 0; r < i.length; r++) this.initElement(i[r])
    },
    initElement: function (e) {
      if (!e.getContext) {
        e.getContext = t,
        e.innerHTML = '',
        e.attachEvent('onpropertychange', i),
        e.attachEvent('onresize', r);
        var s = e.attributes;
        s.width && s.width.specified ? e.style.width = s.width.nodeValue + 'px' : e.width = e.clientWidth,
        s.height && s.height.specified ? e.style.height = s.height.nodeValue + 'px' : e.height = e.clientHeight
      }
      return e
    }
  };
  b.init();
  for (var T = [
  ], P = 0; 16 > P; P++) for (var k = 0; 16 > k; k++) T[16 * P + k] = P.toString(16) + k.toString(16);
  var E = l.prototype;
  E.clearRect = function () {
    this.element_.innerHTML = ''
  },
  E.beginPath = function () {
    this.currentPath_ = [
    ]
  },
  E.moveTo = function (t, e) {
    var i = this.getCoords_(t, e);
    this.currentPath_.push({
      type: 'moveTo',
      x: i.x,
      y: i.y
    }),
    this.currentX_ = i.x,
    this.currentY_ = i.y
  },
  E.lineTo = function (t, e) {
    var i = this.getCoords_(t, e);
    this.currentPath_.push({
      type: 'lineTo',
      x: i.x,
      y: i.y
    }),
    this.currentX_ = i.x,
    this.currentY_ = i.y
  },
  E.bezierCurveTo = function (t, e, i, r, s, n) {
    var a = this.getCoords_(s, n),
    o = this.getCoords_(t, e),
    h = this.getCoords_(i, r);
    c(this, o, h, a)
  },
  E.quadraticCurveTo = function (t, e, i, r) {
    var s = this.getCoords_(t, e),
    n = this.getCoords_(i, r),
    a = {
      x: this.currentX_ + 2 / 3 * (s.x - this.currentX_),
      y: this.currentY_ + 2 / 3 * (s.y - this.currentY_)
    },
    o = {
      x: a.x + (n.x - this.currentX_) / 3,
      y: a.y + (n.y - this.currentY_) / 3
    };
    c(this, a, o, n)
  },
  E.arc = function (t, e, i, r, s, n) {
    i *= S;
    var a = n ? 'at' : 'wa',
    o = t + m(r) * i - w,
    h = e + d(r) * i - w,
    l = t + m(s) * i - w,
    c = e + d(s) * i - w;
    o != l || n || (o += 0.125);
    var u = this.getCoords_(t, e),
    _ = this.getCoords_(o, h),
    f = this.getCoords_(l, c);
    this.currentPath_.push({
      type: a,
      x: u.x,
      y: u.y,
      radius: i,
      xStart: _.x,
      yStart: _.y,
      xEnd: f.x,
      yEnd: f.y
    })
  },
  E.rect = function (t, e, i, r) {
    this.moveTo(t, e),
    this.lineTo(t + i, e),
    this.lineTo(t + i, e + r),
    this.lineTo(t, e + r),
    this.closePath()
  },
  E.strokeRect = function (t, e, i, r) {
    var s = this.currentPath_;
    this.beginPath(),
    this.moveTo(t, e),
    this.lineTo(t + i, e),
    this.lineTo(t + i, e + r),
    this.lineTo(t, e + r),
    this.closePath(),
    this.stroke(),
    this.currentPath_ = s
  },
  E.fillRect = function (t, e, i, r) {
    var s = this.currentPath_;
    this.beginPath(),
    this.moveTo(t, e),
    this.lineTo(t + i, e),
    this.lineTo(t + i, e + r),
    this.lineTo(t, e + r),
    this.closePath(),
    this.fill(),
    this.currentPath_ = s
  },
  E.createLinearGradient = function (t, e, i, r) {
    var s = new f('gradient');
    return s.x0_ = t,
    s.y0_ = e,
    s.x1_ = i,
    s.y1_ = r,
    s
  },
  E.createRadialGradient = function (t, e, i, r, s, n) {
    var a = new f('gradientradial');
    return a.x0_ = t,
    a.y0_ = e,
    a.r0_ = i,
    a.x1_ = r,
    a.y1_ = s,
    a.r1_ = n,
    a
  },
  E.drawImage = function (t) {
    var e,
    i,
    r,
    s,
    n,
    a,
    o,
    h,
    l = t.runtimeStyle.width,
    c = t.runtimeStyle.height;
    t.runtimeStyle.width = 'auto',
    t.runtimeStyle.height = 'auto';
    var u = t.width,
    _ = t.height;
    if (t.runtimeStyle.width = l, t.runtimeStyle.height = c, 3 == arguments.length) e = arguments[1],
    i = arguments[2],
    n = a = 0,
    o = r = u,
    h = s = _;
     else if (5 == arguments.length) e = arguments[1],
    i = arguments[2],
    r = arguments[3],
    s = arguments[4],
    n = a = 0,
    o = u,
    h = _;
     else {
      if (9 != arguments.length) throw Error('Invalid number of arguments');
      n = arguments[1],
      a = arguments[2],
      o = arguments[3],
      h = arguments[4],
      e = arguments[5],
      i = arguments[6],
      r = arguments[7],
      s = arguments[8]
    }
    var f = this.getCoords_(e, i),
    p = [
    ],
    d = 10,
    m = 10;
    if (p.push(' <g_vml_:group', ' coordsize="', S * d, ',', S * m, '"', ' coordorigin="0,0"', ' style="width:', d, 'px;height:', m, 'px;position:absolute;'), 1 != this.m_[0][0] || this.m_[0][1]) {
      var x = [
      ];
      x.push('M11=', this.m_[0][0], ',', 'M12=', this.m_[1][0], ',', 'M21=', this.m_[0][1], ',', 'M22=', this.m_[1][1], ',', 'Dx=', g(f.x / S), ',', 'Dy=', g(f.y / S), '');
      var v = f,
      w = this.getCoords_(e + r, i),
      C = this.getCoords_(e, i + s),
      b = this.getCoords_(e + r, i + s);
      v.x = y.max(v.x, w.x, C.x, b.x),
      v.y = y.max(v.y, w.y, C.y, b.y),
      p.push('padding:0 ', g(v.x / S), 'px ', g(v.y / S), 'px 0;filter:progid:DXImageTransform.Microsoft.Matrix(', x.join(''), ', sizingmethod=\'clip\');')
    } else p.push('top:', g(f.y / S), 'px;left:', g(f.x / S), 'px;');
    p.push(' ">', '<g_vml_:image src="', t.src, '"', ' style="width:', S * r, 'px;', ' height:', S * s, 'px;"', ' cropleft="', n / u, '"', ' croptop="', a / _, '"', ' cropright="', (u - n - o) / u, '"', ' cropbottom="', (_ - a - h) / _, '"', ' />', '</g_vml_:group>'),
    this.element_.insertAdjacentHTML('BeforeEnd', p.join(''))
  },
  E.stroke = function (t) {
    var e = [
    ],
    i = o(t ? this.fillStyle : this.strokeStyle),
    r = i.color,
    s = i.alpha * this.globalAlpha,
    n = 10,
    a = 10;
    e.push('<g_vml_:shape', ' filled="', !!t, '"', ' style="position:absolute;width:', n, 'px;height:', a, 'px;"', ' coordorigin="0 0" coordsize="', S * n, ' ', S * a, '"', ' stroked="', !t, '"', ' path="');
    for (var l = {
      x: null,
      y: null
    }, c = {
      x: null,
      y: null
    }, u = 0; u < this.currentPath_.length; u++) {
      var _,
      f = this.currentPath_[u];
      switch (f.type) {
        case 'moveTo':
          _ = f,
          e.push(' m ', g(f.x), ',', g(f.y));
          break;
        case 'lineTo':
          e.push(' l ', g(f.x), ',', g(f.y));
          break;
        case 'close':
          e.push(' x '),
          f = null;
          break;
        case 'bezierCurveTo':
          e.push(' c ', g(f.cp1x), ',', g(f.cp1y), ',', g(f.cp2x), ',', g(f.cp2y), ',', g(f.x), ',', g(f.y));
          break;
        case 'at':
        case 'wa':
          e.push(' ', f.type, ' ', g(f.x - this.arcScaleX_ * f.radius), ',', g(f.y - this.arcScaleY_ * f.radius), ' ', g(f.x + this.arcScaleX_ * f.radius), ',', g(f.y + this.arcScaleY_ * f.radius), ' ', g(f.xStart), ',', g(f.yStart), ' ', g(f.xEnd), ',', g(f.yEnd))
      }
      f && ((null == l.x || f.x < l.x) && (l.x = f.x), (null == c.x || f.x > c.x) && (c.x = f.x), (null == l.y || f.y < l.y) && (l.y = f.y), (null == c.y || f.y > c.y) && (c.y = f.y))
    }
    if (e.push(' ">'), t) if ('object' == typeof this.fillStyle) {
      var p = this.fillStyle,
      d = 0,
      m = {
        x: 0,
        y: 0
      },
      x = 0,
      v = 1;
      if ('gradient' == p.type_) {
        var w = p.x0_ / this.arcScaleX_,
        C = p.y0_ / this.arcScaleY_,
        b = p.x1_ / this.arcScaleX_,
        T = p.y1_ / this.arcScaleY_,
        P = this.getCoords_(w, C),
        k = this.getCoords_(b, T),
        E = k.x - P.x,
        M = k.y - P.y;
        d = 180 * Math.atan2(E, M) / Math.PI,
        0 > d && (d += 360),
        0.000001 > d && (d = 0)
      } else {
        var P = this.getCoords_(p.x0_, p.y0_),
        X = c.x - l.x,
        Y = c.y - l.y;
        m = {
          x: (P.x - l.x) / X,
          y: (P.y - l.y) / Y
        },
        X /= this.arcScaleX_ * S,
        Y /= this.arcScaleY_ * S;
        var L = y.max(X, Y);
        x = 2 * p.r0_ / L,
        v = 2 * p.r1_ / L - x
      }
      var A = p.colors_;
      A.sort(function (t, e) {
        return t.offset - e.offset
      });
      for (var j = A.length, V = A[0].color, z = A[j - 1].color, H = A[0].alpha * this.globalAlpha, R = A[j - 1].alpha * this.globalAlpha, W = [
      ], u = 0; j > u; u++) {
        var O = A[u];
        W.push(O.offset * v + x + ' ' + O.color)
      }
      e.push('<g_vml_:fill type="', p.type_, '"', ' method="none" focus="100%"', ' color="', V, '"', ' color2="', z, '"', ' colors="', W.join(','), '"', ' opacity="', R, '"', ' g_o_:opacity2="', H, '"', ' angle="', d, '"', ' focusposition="', m.x, ',', m.y, '" />')
    } else e.push('<g_vml_:fill color="', r, '" opacity="', s, '" />');
     else {
      var D = this.lineScale_ * this.lineWidth;
      1 > D && (s *= D),
      e.push('<g_vml_:stroke', ' opacity="', s, '"', ' joinstyle="', this.lineJoin, '"', ' miterlimit="', this.miterLimit, '"', ' endcap="', h(this.lineCap), '"', ' weight="', D, 'px"', ' color="', r, '" />')
    }
    e.push('</g_vml_:shape>'),
    this.element_.insertAdjacentHTML('beforeEnd', e.join(''))
  },
  E.fill = function () {
    this.stroke(!0)
  },
  E.closePath = function () {
    this.currentPath_.push({
      type: 'close'
    })
  },
  E.getCoords_ = function (t, e) {
    var i = this.m_;
    return {
      x: S * (t * i[0][0] + e * i[1][0] + i[2][0]) - w,
      y: S * (t * i[0][1] + e * i[1][1] + i[2][1]) - w
    }
  },
  E.save = function () {
    var t = {
    };
    a(this, t),
    this.aStack_.push(t),
    this.mStack_.push(this.m_),
    this.m_ = n(s(), this.m_)
  },
  E.restore = function () {
    a(this.aStack_.pop(), this),
    this.m_ = this.mStack_.pop()
  },
  E.translate = function (t, e) {
    var i = [
      [1,
      0,
      0],
      [
        0,
        1,
        0
      ],
      [
        t,
        e,
        1
      ]
    ];
    _(this, n(i, this.m_), !1)
  },
  E.rotate = function (t) {
    var e = m(t),
    i = d(t),
    r = [
      [e,
      i,
      0],
      [
        - i,
        e,
        0
      ],
      [
        0,
        0,
        1
      ]
    ];
    _(this, n(r, this.m_), !1)
  },
  E.scale = function (t, e) {
    this.arcScaleX_ *= t,
    this.arcScaleY_ *= e;
    var i = [
      [t,
      0,
      0],
      [
        0,
        e,
        0
      ],
      [
        0,
        0,
        1
      ]
    ];
    _(this, n(i, this.m_), !0)
  },
  E.transform = function (t, e, i, r, s, a) {
    var o = [
      [t,
      e,
      0],
      [
        i,
        r,
        0
      ],
      [
        s,
        a,
        1
      ]
    ];
    _(this, n(o, this.m_), !0)
  },
  E.setTransform = function (t, e, i, r, s, n) {
    var a = [
      [t,
      e,
      0],
      [
        i,
        r,
        0
      ],
      [
        s,
        n,
        1
      ]
    ];
    _(this, a, !0)
  },
  E.clip = function () {
  },
  E.arcTo = function () {
  },
  E.createPattern = function () {
    return new p
  },
  f.prototype.addColorStop = function (t, e) {
    e = o(e),
    this.colors_.push({
      offset: t,
      color: e.color,
      alpha: e.alpha
    })
  },
  G_vmlCanvasManager = b,
  CanvasRenderingContext2D = l,
  CanvasGradient = f,
  CanvasPattern = p
}();
(function (e) {
  if (typeof define === 'function' && define.amd) {
    define(['jquery'], e)
  } else {
    e(jQuery)
  }
}) (function (e) {
  'use strict';
  var t = {
  },
  n = Math.max,
  r = Math.min;
  t.c = {
  };
  t.c.d = e(document);
  t.c.t = function (e) {
    return e.originalEvent.touches.length - 1
  };
  t.o = function () {
    var n = this;
    this.o = null;
    this.$ = null;
    this.i = null;
    this.g = null;
    this.v = null;
    this.cv = null;
    this.x = 0;
    this.y = 0;
    this.w = 0;
    this.h = 0;
    this.$c = null;
    this.c = null;
    this.t = 0;
    this.isInit = false;
    this.fgColor = null;
    this.pColor = null;
    this.dH = null;
    this.cH = null;
    this.eH = null;
    this.rH = null;
    this.scale = 1;
    this.relative = false;
    this.relativeWidth = false;
    this.relativeHeight = false;
    this.$div = null;
    this.run = function () {
      var t = function (e, t) {
        var r;
        for (r in t) {
          n.o[r] = t[r]
        }
        n._carve().init();
        n._configure()._draw()
      };
      if (this.$.data('kontroled')) return;
      this.$.data('kontroled', true);
      this.extend();
      this.o = e.extend({
        min: this.$.data('min') !== undefined ? this.$.data('min')  : 0,
        max: this.$.data('max') !== undefined ? this.$.data('max')  : 100,
        stopper: true,
        readOnly: this.$.data('readonly') || this.$.attr('readonly') === 'readonly',
        cursor: this.$.data('cursor') === true && 30 || this.$.data('cursor') || 0,
        thickness: this.$.data('thickness') && Math.max(Math.min(this.$.data('thickness'), 1), 0.01) || 0.35,
        lineCap: this.$.data('linecap') || 'butt',
        width: this.$.data('width') || 200,
        height: this.$.data('height') || 200,
        displayInput: this.$.data('displayinput') == null || this.$.data('displayinput'),
        displayPrevious: this.$.data('displayprevious'),
        fgColor: this.$.data('fgcolor') || '#87CEEB',
        inputColor: this.$.data('inputcolor'),
        font: this.$.data('font') || 'Arial',
        fontWeight: this.$.data('font-weight') || 'bold',
        inline: false,
        step: this.$.data('step') || 1,
        rotation: this.$.data('rotation'),
        draw: null,
        change: null,
        cancel: null,
        release: null,
        format: function (e) {
          return e
        },
        parse: function (e) {
          return parseFloat(e)
        }
      }, this.o);
      this.o.flip = this.o.rotation === 'anticlockwise' || this.o.rotation === 'acw';
      if (!this.o.inputColor) {
        this.o.inputColor = this.o.fgColor
      }
      if (this.$.is('fieldset')) {
        this.v = {
        };
        this.i = this.$.find('input');
        this.i.each(function (t) {
          var r = e(this);
          n.i[t] = r;
          n.v[t] = n.o.parse(r.val());
          r.bind('change blur', function () {
            var e = {
            };
            e[t] = r.val();
            n.val(n._validate(e))
          })
        });
        this.$.find('legend').remove()
      } else {
        this.i = this.$;
        this.v = this.o.parse(this.$.val());
        this.v === '' && (this.v = this.o.min);
        this.$.bind('change blur', function () {
          n.val(n._validate(n.o.parse(n.$.val())))
        })
      }
      !this.o.displayInput && this.$.hide();
      this.$c = e(document.createElement('canvas')).attr({
        width: this.o.width,
        height: this.o.height
      });
      this.$div = e('<div style="' + (this.o.inline ? 'display:inline;' : '') + 'width:' + this.o.width + 'px;height:' + this.o.height + 'px;' + '"></div>');
      this.$.wrap(this.$div).before(this.$c);
      this.$div = this.$.parent();
      if (typeof G_vmlCanvasManager !== 'undefined') {
        G_vmlCanvasManager.initElement(this.$c[0])
      }
      this.c = this.$c[0].getContext ? this.$c[0].getContext('2d')  : null;
      if (!this.c) {
        throw {
          name: 'CanvasNotSupportedException',
          message: 'Canvas not supported. Please use excanvas on IE8.0.',
          toString: function () {
            return this.name + ': ' + this.message
          }
        }
      }
      this.scale = (window.devicePixelRatio || 1) / (this.c.webkitBackingStorePixelRatio || this.c.mozBackingStorePixelRatio || this.c.msBackingStorePixelRatio || this.c.oBackingStorePixelRatio || this.c.backingStorePixelRatio || 1);
      this.relativeWidth = this.o.width % 1 !== 0 && this.o.width.indexOf('%');
      this.relativeHeight = this.o.height % 1 !== 0 && this.o.height.indexOf('%');
      this.relative = this.relativeWidth || this.relativeHeight;
      this._carve();
      if (this.v instanceof Object) {
        this.cv = {
        };
        this.copy(this.v, this.cv)
      } else {
        this.cv = this.v
      }
      this.$.bind('configure', t).parent().bind('configure', t);
      this._listen()._configure()._xy().init();
      this.isInit = true;
      this.$.val(this.o.format(this.v));
      this._draw();
      return this
    };
    this._carve = function () {
      if (this.relative) {
        var e = this.relativeWidth ? this.$div.parent().width() * parseInt(this.o.width) / 100 : this.$div.parent().width(),
        t = this.relativeHeight ? this.$div.parent().height() * parseInt(this.o.height) / 100 : this.$div.parent().height();
        this.w = this.h = Math.min(e, t)
      } else {
        this.w = this.o.width;
        this.h = this.o.height
      }
      this.$div.css({
        width: this.w + 'px',
        height: this.h + 'px'
      });
      this.$c.attr({
        width: this.w,
        height: this.h
      });
      if (this.scale !== 1) {
        this.$c[0].width = this.$c[0].width * this.scale;
        this.$c[0].height = this.$c[0].height * this.scale;
        this.$c.width(this.w);
        this.$c.height(this.h)
      }
      return this
    };
    this._draw = function () {
      var e = true;
      n.g = n.c;
      n.clear();
      n.dH && (e = n.dH());
      e !== false && n.draw()
    };
    this._touch = function (e) {
      var r = function (e) {
        var t = n.xy2val(e.originalEvent.touches[n.t].pageX, e.originalEvent.touches[n.t].pageY);
        if (t == n.cv) return;
        if (n.cH && n.cH(t) === false) return;
        n.change(n._validate(t));
        n._draw()
      };
      this.t = t.c.t(e);
      r(e);
      t.c.d.bind('touchmove.k', r).bind('touchend.k', function () {
        t.c.d.unbind('touchmove.k touchend.k');
        n.val(n.cv)
      });
      return this
    };
    this._mouse = function (e) {
      var r = function (e) {
        var t = n.xy2val(e.pageX, e.pageY);
        if (t == n.cv) return;
        if (n.cH && n.cH(t) === false) return;
        n.change(n._validate(t));
        n._draw()
      };
      r(e);
      t.c.d.bind('mousemove.k', r).bind('keyup.k', function (e) {
        if (e.keyCode === 27) {
          t.c.d.unbind('mouseup.k mousemove.k keyup.k');
          if (n.eH && n.eH() === false) return;
          n.cancel()
        }
      }).bind('mouseup.k', function (e) {
        t.c.d.unbind('mousemove.k mouseup.k keyup.k');
        n.val(n.cv)
      });
      return this
    };
    this._xy = function () {
      var e = this.$c.offset();
      this.x = e.left;
      this.y = e.top;
      return this
    };
    this._listen = function () {
      if (!this.o.readOnly) {
        this.$c.bind('mousedown', function (e) {
          e.preventDefault();
          n._xy()._mouse(e)
        }).bind('touchstart', function (e) {
          e.preventDefault();
          n._xy()._touch(e)
        });
        this.listen()
      } else {
        this.$.attr('readonly', 'readonly')
      }
      if (this.relative) {
        e(window).resize(function () {
          n._carve().init();
          n._draw()
        })
      }
      return this
    };
    this._configure = function () {
      if (this.o.draw) this.dH = this.o.draw;
      if (this.o.change) this.cH = this.o.change;
      if (this.o.cancel) this.eH = this.o.cancel;
      if (this.o.release) this.rH = this.o.release;
      if (this.o.displayPrevious) {
        this.pColor = this.h2rgba(this.o.fgColor, '0.4');
        this.fgColor = this.h2rgba(this.o.fgColor, '0.6')
      } else {
        this.fgColor = this.o.fgColor
      }
      return this
    };
    this._clear = function () {
      this.$c[0].width = this.$c[0].width
    };
    this._validate = function (e) {
      var t = ~~((e < 0 ? - 0.5 : 0.5) + e / this.o.step) * this.o.step;
      return Math.round(t * 100) / 100
    };
    this.listen = function () {
    };
    this.extend = function () {
    };
    this.init = function () {
    };
    this.change = function (e) {
    };
    this.val = function (e) {
    };
    this.xy2val = function (e, t) {
    };
    this.draw = function () {
    };
    this.clear = function () {
      this._clear()
    };
    this.h2rgba = function (e, t) {
      var n;
      e = e.substring(1, 7);
      n = [
        parseInt(e.substring(0, 2), 16),
        parseInt(e.substring(2, 4), 16),
        parseInt(e.substring(4, 6), 16)
      ];
      return 'rgba(' + n[0] + ',' + n[1] + ',' + n[2] + ',' + t + ')'
    };
    this.copy = function (e, t) {
      for (var n in e) {
        t[n] = e[n]
      }
    }
  };
  t.Dial = function () {
    t.o.call(this);
    this.startAngle = null;
    this.xy = null;
    this.radius = null;
    this.lineWidth = null;
    this.cursorExt = null;
    this.w2 = null;
    this.PI2 = 2 * Math.PI;
    this.extend = function () {
      this.o = e.extend({
        bgColor: this.$.data('bgcolor') || '#EEEEEE',
        angleOffset: this.$.data('angleoffset') || 0,
        angleArc: this.$.data('anglearc') || 360,
        inline: true
      }, this.o)
    };
    this.val = function (e, t) {
      if (null != e) {
        e = this.o.parse(e);
        if (t !== false && e != this.v && this.rH && this.rH(e) === false) {
          return
        }
        this.cv = this.o.stopper ? n(r(e, this.o.max), this.o.min)  : e;
        this.v = this.cv;
        this.$.val(this.o.format(this.v));
        this._draw()
      } else {
        return this.v
      }
    };
    this.xy2val = function (e, t) {
      var i,
      s;
      i = Math.atan2(e - (this.x + this.w2), - (t - this.y - this.w2)) - this.angleOffset;
      if (this.o.flip) {
        i = this.angleArc - i - this.PI2
      }
      if (this.angleArc != this.PI2 && i < 0 && i > - 0.5) {
        i = 0
      } else if (i < 0) {
        i += this.PI2
      }
      s = i * (this.o.max - this.o.min) / this.angleArc + this.o.min;
      this.o.stopper && (s = n(r(s, this.o.max), this.o.min));
      return s
    };
    this.listen = function () {
      var t = this,
      i,
      s,
      o = function (e) {
        e.preventDefault();
        var o = e.originalEvent,
        u = o.detail || o.wheelDeltaX,
        a = o.detail || o.wheelDeltaY,
        f = t._validate(t.o.parse(t.$.val())) + (u > 0 || a > 0 ? t.o.step : u < 0 || a < 0 ? - t.o.step : 0);
        f = n(r(f, t.o.max), t.o.min);
        t.val(f, false);
        if (t.rH) {
          clearTimeout(i);
          i = setTimeout(function () {
            t.rH(f);
            i = null
          }, 100);
          if (!s) {
            s = setTimeout(function () {
              if (i) t.rH(f);
              s = null
            }, 200)
          }
        }
      },
      u,
      a,
      f = 1,
      l = {
        37: - t.o.step,
        38: t.o.step,
        39: t.o.step,
        40: - t.o.step
      };
      this.$.bind('keydown', function (i) {
        var s = i.keyCode;
        if (s >= 96 && s <= 105) {
          s = i.keyCode = s - 48
        }
        u = parseInt(String.fromCharCode(s));
        if (isNaN(u)) {
          s !== 13 && s !== 8 && s !== 9 && s !== 189 && (s !== 190 || t.$.val().match(/\./)) && i.preventDefault();
          if (e.inArray(s, [
            37,
            38,
            39,
            40
          ]) > - 1) {
            i.preventDefault();
            var o = t.o.parse(t.$.val()) + l[s] * f;
            t.o.stopper && (o = n(r(o, t.o.max), t.o.min));
            t.change(t._validate(o));
            t._draw();
            a = window.setTimeout(function () {
              f *= 2
            }, 30)
          }
        }
      }).bind('keyup', function (e) {
        if (isNaN(u)) {
          if (a) {
            window.clearTimeout(a);
            a = null;
            f = 1;
            t.val(t.$.val())
          }
        } else {
          t.$.val() > t.o.max && t.$.val(t.o.max) || t.$.val() < t.o.min && t.$.val(t.o.min)
        }
      });
      this.$c.bind('mousewheel DOMMouseScroll', o);
      this.$.bind('mousewheel DOMMouseScroll', o)
    };
    this.init = function () {
      if (this.v < this.o.min || this.v > this.o.max) {
        this.v = this.o.min
      }
      this.$.val(this.v);
      this.w2 = this.w / 2;
      this.cursorExt = this.o.cursor / 100;
      this.xy = this.w2 * this.scale;
      this.lineWidth = this.xy * this.o.thickness;
      this.lineCap = this.o.lineCap;
      this.radius = this.xy - this.lineWidth / 2;
      this.o.angleOffset && (this.o.angleOffset = isNaN(this.o.angleOffset) ? 0 : this.o.angleOffset);
      this.o.angleArc && (this.o.angleArc = isNaN(this.o.angleArc) ? this.PI2 : this.o.angleArc);
      this.angleOffset = this.o.angleOffset * Math.PI / 180;
      this.angleArc = this.o.angleArc * Math.PI / 180;
      this.startAngle = 1.5 * Math.PI + this.angleOffset;
      this.endAngle = 1.5 * Math.PI + this.angleOffset + this.angleArc;
      var e = n(String(Math.abs(this.o.max)).length, String(Math.abs(this.o.min)).length, 2) + 2;
      this.o.displayInput && this.i.css({
        width: (this.w / 2 + 4 >> 0) + 'px',
        height: (this.w / 3 >> 0) + 'px',
        position: 'absolute',
        'vertical-align': 'middle',
        'margin-top': (this.w / 3 >> 0) + 'px',
        'margin-left': '-' + (this.w * 3 / 4 + 2 >> 0) + 'px',
        border: 0,
        background: 'none',
        font: this.o.fontWeight + ' ' + (this.w / e >> 0) + 'px ' + this.o.font,
        'text-align': 'center',
        color: this.o.inputColor || this.o.fgColor,
        padding: '0px',
        '-webkit-appearance': 'none'
      }) || this.i.css({
        width: '0px',
        visibility: 'hidden'
      })
    };
    this.change = function (e) {
      this.cv = e;
      this.$.val(this.o.format(e))
    };
    this.angle = function (e) {
      return (e - this.o.min) * this.angleArc / (this.o.max - this.o.min)
    };
    this.arc = function (e) {
      var t,
      n;
      e = this.angle(e);
      if (this.o.flip) {
        t = this.endAngle + 0.00001;
        n = t - e - 0.00001
      } else {
        t = this.startAngle - 0.00001;
        n = t + e + 0.00001
      }
      this.o.cursor && (t = n - this.cursorExt) && (n = n + this.cursorExt);
      return {
        s: t,
        e: n,
        d: this.o.flip && !this.o.cursor
      }
    };
    this.draw = function () {
      var e = this.g,
      t = this.arc(this.cv),
      n,
      r = 1;
      e.lineWidth = this.lineWidth;
      e.lineCap = this.lineCap;
      if (this.o.bgColor !== 'none') {
        e.beginPath();
        e.strokeStyle = this.o.bgColor;
        e.arc(this.xy, this.xy, this.radius, this.endAngle - 0.00001, this.startAngle + 0.00001, true);
        e.stroke()
      }
      if (this.o.displayPrevious) {
        n = this.arc(this.v);
        e.beginPath();
        e.strokeStyle = this.pColor;
        e.arc(this.xy, this.xy, this.radius, n.s, n.e, n.d);
        e.stroke();
        r = this.cv == this.v
      }
      e.beginPath();
      e.strokeStyle = r ? this.o.fgColor : this.fgColor;
      e.arc(this.xy, this.xy, this.radius, t.s, t.e, t.d);
      e.stroke()
    };
    this.cancel = function () {
      this.val(this.v)
    }
  };
  e.fn.dial = e.fn.knob = function (n) {
    return this.each(function () {
      var r = new t.Dial;
      r.o = n;
      r.$ = e(this);
      r.run()
    }).parent()
  }
});
$(document).ready(function () {
  $('.dial').each(function () {
    var elm = $(this)
    var width = elm.attr('data-width')
    var height = elm.attr('data-height')
    var color = elm.attr('data-color')
    elm.val(0).trigger('change').delay(500)
    elm.knob({
      'min': 0,
      'max': 100,
      'readOnly': true,
      'width': width,
      'height': height,
      'fgColor': color,
      'bgColor': 'transparent',
      'dynamicDraw': true,
      'thickness': 0.2,
      'tickColorizeValues': true,
    });
    var tmr = self.setInterval(function () {
      myDelay(elm, elm.attr('value'))
    }, 35);
    var m = 0
    function myDelay(elm, val) {
      console.dir(elm)
      m += 5
      elm.val(m).trigger('change')
      if (m == val) {
        window.clearInterval(tmr)
      }
    }
  });
});